VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellFolder2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const CLSID_ShellFolder2 As String = ""
    
Private Const IID_IShellFolder2 As String = _
    "{93f2f68c-1d1b-11d3-a30e-00c04f79abd1}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_ParseDisplayName
    vtb_EnumObjects
    vtb_BindToObject
    vtb_BindToStorage
    vtb_CompareIDs
    vtb_CreateViewObject
    vtb_GetAttributesOf
    vtb_GetUIObjectOf
    vtb_GetDisplayNameOf
    vtb_SetNameOf
    vtb_GetDefaultSearchGUID
    vtb_EnumSearches
    vtb_GetDefaultColumn
    vtb_GetDefaultColumnState
    vtb_GetDetailsEx
    vtb_GetDetailsOf
    vtb_MapColumnToSCID
End Enum

Public Function ParseDisplayName(ByVal pszDisplayName As String) As Long

    Dim lRet As Long
    Dim ppszDisplayName As Long
    Dim pchEaten As Long
    Dim ppchEaten As Long
    Dim ppidl As Long
    Dim pppidl As Long
    
    ppszDisplayName = StrPtr(pszDisplayName)
    ppchEaten = VarPtr(pchEaten)
    pppidl = VarPtr(ppidl)
    
    If x_OleInvoke(vtb_ParseDisplayName, 0&, 0&, ppszDisplayName, ppchEaten, pppidl, 0&) Then

        lRet = ppidl

    End If

    ParseDisplayName = lRet
    
End Function

Public Function EnumObjects(ByVal hwndOwner As Long, ByVal grfFlags As Long) As Long

    Dim lRet As Long
    Dim ppenumIDList As Long
    Dim pppenumIDList As Long

    pppenumIDList = VarPtr(ppenumIDList)

    If x_OleInvoke(vtb_EnumObjects, hwndOwner, grfFlags, pppenumIDList) Then

        lRet = ppenumIDList

    End If

    EnumObjects = lRet
    
End Function

Public Function BindToObject(ByVal pidl As Long, ByVal pbc As Long, ByVal riid As Long) As Long

    Dim lRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToObject, pidl, pbc, riid, pppvOut) Then

        lRet = ppvOut

    End If

    BindToObject = lRet
    
End Function

Public Function CreateViewObject(ByVal hwndOwner As Long, ByVal riid As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim pppv As Long
    
    pppv = VarPtr(ppv)
    
    If x_OleInvoke(vtb_CreateViewObject, hwndOwner, riid, pppv) Then

        lRet = ppv

    End If

    CreateViewObject = lRet
    
End Function

Public Function GetAttributesOf(ByVal cidl As Long, ByVal apidl As Long, ByRef rgfInOut As Long) As Boolean
    
    Dim bRet As Boolean
    Dim prgfInOut As Long
    
    prgfInOut = VarPtr(rgfInOut)
    
    If x_OleInvoke(vtb_GetAttributesOf, cidl, apidl, prgfInOut) Then

        bRet = True

    End If

    GetAttributesOf = bRet
    
End Function

Public Function GetUIObjectOf(ByVal hwndOwner As Long, ByVal cidl As Long, ByVal _
    apidl As Long, ByVal riid As Long) As Long
    
    Dim lRet As Long
    Dim ppv As Long
    Dim pppv As Long
    Dim rgfReserved As Long
    Dim prgfReserved As Long
    
    rgfReserved = 0&
    
    pppv = VarPtr(ppv)
    prgfReserved = VarPtr(rgfReserved)
    
    If x_OleInvoke(vtb_GetUIObjectOf, hwndOwner, cidl, apidl, riid, prgfReserved, pppv) Then
    
        lRet = ppv
        
    End If
    
    GetUIObjectOf = lRet
    
End Function

Public Function GetDisplayNameOf(ByVal pidl As Long, ByVal uFlags As Long) As Long

    Dim lRet As Long
    Dim pName As Long
    Dim ppName As Long
    
    ppName = VarPtr(pName)

    If x_OleInvoke(vtb_GetDisplayNameOf, pidl, uFlags, ppName) Then
    
        lRet = pName
        
    End If

    GetDisplayNameOf = lRet
    
End Function


Public Function GetDetailsOf(ByVal pidl As Long, ByVal iColumn As Long, ByRef psd As Long) As Boolean
    
    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_GetDetailsOf, pidl, iColumn, psd) Then

        bRet = True

    End If

    GetDetailsOf = bRet
    
End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)
    
    m_Interface.RaiseErrors = Raise
    
End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_ShellFolder2, _
            IID_IShellFolder2)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIShellFolder2", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub




