Attribute VB_Name = "modZipInfo"
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const S_OK As Long = 0&
Private Const MAX_PATH As Long = 260&

Private Const IID_IShellFolder2 As String = "{93f2f68c-1d1b-11d3-a30e-00c04f79abd1}"

' IShellFolder.EnumObjects
Public Enum SHCONTF
    SHCONTF_CHECKING_FOR_CHILDREN = &H10
    SHCONTF_FOLDERS = &H20
    SHCONTF_NONFOLDERS = &H40
    SHCONTF_INCLUDEHIDDEN = &H80
    SHCONTF_INIT_ON_FIRST_NEXT = &H100
    SHCONTF_NETPRINTERSRCH = &H200
    SHCONTF_SHAREABLE = &H400
    SHCONTF_STORAGE = &H800
    SHCONTF_NAVIGATION_ENUM = &H1000
    SHCONTF_FASTITEMS = &H2000
    SHCONTF_FLATLIST = &H4000
    SHCONTF_ENABLE_ASYNC = &H8000
    SHCONTF_INCLUDESUPERHIDDEN = &H10000
End Enum

' SHELLDETAILS.str
Private Type STRRET
    uType As Long
    cbStr(0 To MAX_PATH - 1) As Byte
End Type

'IShellFolder2.GetDetailsOf
Private Type SHELLDETAILS
    fmt As Long
    cxChar As Long
    str As STRRET
End Type

Public Type FileInfo
   FileName As String
   FileType As String
   PackedSize As String
   HasAPassword As String
   Method As String
   Size As String
   Ratio As String
   Date As String
   CRC32 As String
End Type

' **************** Shell32.dll ****************
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

' **************** Shlwapi.dll ****************
Private Declare Function StrRetToStrA Lib "shlwapi" ( _
                         ByVal pstr As Long, _
                         ByVal pidl As Long, _
                         ByRef ppszName As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)

' **************** Oleaut32.dll ****************
Private Declare Function SysAllocString Lib "oleaut32" ( _
                         ByVal psz As Long) As String
                        
Private Function CutNull(ByVal sStr As String) As String
    
    Dim sRet As String
    
    If InStr(1, sStr, Chr$(0)) > 0 Then

        sRet = Mid$(sStr, 1, InStr(1, sStr, Chr$(0)) - 1)

    Else

        sRet = sStr

    End If

    CutNull = sRet
    
End Function
                        
Public Function EnumZipFile(ByVal sZipPath As String, ByVal Flags As SHCONTF, ByRef sReturn() As String) As Long

    Dim szName As String
    Dim lCount As Long
    Dim lPIDL As Long
    Dim lPIDL2 As Long
    Dim plPIDL2 As Long
    Dim pszName As Long
    Dim pIEnumIDList As Long
    Dim pIShellFolder2 As Long
    Dim pIShellFolderDesktop As Long
    Dim tIID_IShellFolder2(3) As Long
    Dim psIID_IShellFolder2 As Long
    Dim ptIID_IShellFolder2 As Long
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim tSHELLDETAILS As SHELLDETAILS

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolderDesktop) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolderDesktop As New clsIShellFolder
        Call IShellFolderDesktop.Initialize(pIShellFolderDesktop)

        lPIDL = IShellFolderDesktop.ParseDisplayName(sZipPath)

        If lPIDL <> 0 Then

            ' IShellFolder2 -> tIID_IShellFolder2
            psIID_IShellFolder2 = StrPtr(IID_IShellFolder2)
            ptIID_IShellFolder2 = VarPtr(tIID_IShellFolder2(0))
            Call IIDFromString(psIID_IShellFolder2, ptIID_IShellFolder2)

            ' IShellFolder an IShellFolder2 binden
            pIShellFolder2 = IShellFolderDesktop.BindToObject(lPIDL, 0&, _
                ptIID_IShellFolder2)

            If pIShellFolder2 <> 0 Then

                ' IShellFolder2 initialisieren
                Dim IShellFolder2 As New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder2)

                ' IEnumIDList abfragen
                pIEnumIDList = IShellFolder2.EnumObjects(0&, Flags)

                If pIEnumIDList <> 0 Then

                    ' IEnumIDList initialisieren
                    Dim IEnumIDList As New clsIEnumIDList
                    Call IEnumIDList.Initialize(pIEnumIDList)

                    plPIDL2 = VarPtr(lPIDL2)
                    ptSHELLDETAILS = VarPtr(tSHELLDETAILS)

                    ' Fehlerbehandlung abschalten
                    Call IEnumIDList.RaiseError(False)
                    
                    ' alle Eintrge durchlaufen
                    Do While IEnumIDList.Fetch(1&, plPIDL2, 0&) = True
                    
                        ' Name abfragen
                        If IShellFolder2.GetDetailsOf(lPIDL2, 0&, ptSHELLDETAILS) _
                            = True Then

                            ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)

                            ' Stringpointer von PIDL zu Stringpointer
                            If StrRetToStrA(ptSHELLDETAILS_str, lPIDL2, pszName) = _
                                S_OK Then
                                
                                ' Stringpointer zu String
                                szName = CutNull(SysAllocString(pszName))
                                szName = Replace$(szName, Chr$(63), vbNullString)
                                
                                If lCount = 0 Then
                                    ReDim sReturn(lCount)
                                Else
                                    ReDim Preserve sReturn(lCount)
                                End If
                                
                                sReturn(lCount) = szName

                                ' aufrumen
                                Call CoTaskMemFree(pszName)

                            End If
                        End If

                        lCount = lCount + 1

                        ' aufrumen
                        Call CoTaskMemFree(lPIDL2)
                        
                    Loop

                    ' Fehlerbehandlung einschalten
                    Call IEnumIDList.RaiseError(True)

                    ' aufrumen
                    Set IEnumIDList = Nothing

                End If

                ' aufrumen
                Set IShellFolder2 = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        ' aufrumen
        Set IShellFolderDesktop = Nothing

    End If

    EnumZipFile = lCount
    
End Function

' liet die Eigenschaften von Dateien und Ordner in einer Zip-Datei aus
Public Function GetZipFileFolderInfo(ByVal sZipPath As String) As FileInfo

    Dim szName As String
    Dim szZipFile As String
    Dim szZipFolder As String
    Dim lPIDL As Long
    Dim lPIDL2 As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim pszName As Long
    Dim lAttribute As Long
    Dim pIShellFolder As Long
    Dim pIShellFolder2 As Long
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim ptIID_IShellFolder2 As Long
    Dim psIID_IShellFolder2 As Long
    Dim tIID_IShellFolder2(3) As Long
    Dim tSHELLDETAILS As SHELLDETAILS
    Dim tFileInfo As FileInfo

    ' Pfad in Ordner und Datei aufteilen
    szZipFolder = Left$(sZipPath, InStrRev(sZipPath, "\") - 1)
    szZipFile = Right$(sZipPath, Len(sZipPath) - InStrRev(sZipPath, "\"))

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)

        ' PIDL vom Ordner ermitteln
        lPIDL = IShellFolder.ParseDisplayName(szZipFolder)

        If lPIDL <> 0 Then

            ' IShellFolder2 -> tIID_IShellFolder2
            psIID_IShellFolder2 = StrPtr(IID_IShellFolder2)
            ptIID_IShellFolder2 = VarPtr(tIID_IShellFolder2(0))
            Call IIDFromString(psIID_IShellFolder2, ptIID_IShellFolder2)

            ' IShellFolder an IShellFolder2 binden
            pIShellFolder2 = IShellFolder.BindToObject(lPIDL, 0&, _
                ptIID_IShellFolder2)

            If pIShellFolder2 <> 0 Then

                ' IShellFolder2 initialisieren
                Dim IShellFolder2 As New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder2)

                ' PIDL von der Datei ermitteln
                lPIDL2 = IShellFolder2.ParseDisplayName(szZipFile)

                ptSHELLDETAILS = VarPtr(tSHELLDETAILS)

                ' Fehlerbehandlung abschalten
                Call IShellFolder2.RaiseError(False)
                
                ' derzeit knnen 8 Eigenschaften abgefragt werden
                For lItem = 0 To 8

                    ' eine Eigenscahft abfragen
                    If IShellFolder2.GetDetailsOf(lPIDL2, lItem, ptSHELLDETAILS) = _
                        True Then
                        
                        ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)
                        
                        ' Stringpointer von PIDL zu Stringpointer
                        If StrRetToStrA(ptSHELLDETAILS_str, lPIDL2, pszName) = S_OK Then

                            ' Stringpointer zu String
                            szName = CutNull(SysAllocString(pszName))
                            szName = Replace$(szName, Chr$(63), vbNullString)
                            
                            ' entsprechend dem Index die Informationen zuweisen
                            Select Case lItem

                            Case 0
                                tFileInfo.FileName = szName

                            Case 1
                                tFileInfo.FileType = szName

                            Case 2
                                tFileInfo.PackedSize = szName

                            Case 3
                                tFileInfo.HasAPassword = szName

                            Case 4
                                tFileInfo.Method = szName

                            Case 5
                                tFileInfo.Size = szName

                            Case 6
                                tFileInfo.Ratio = szName

                            Case 7
                                tFileInfo.Date = szName

                            Case 8
                                tFileInfo.CRC32 = szName

                            End Select

                            ' aufrumen
                            Call CoTaskMemFree(pszName)

                        End If

                    End If

                Next

                ' Fehlerbehandlung einschalten
                Call IShellFolder2.RaiseError(True)

                ' aufrumen
                Call CoTaskMemFree(lPIDL2)

                ' aufrumen
                Set IShellFolder2 = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        ' aufrumen
        Set IShellFolder = Nothing

    End If

    GetZipFileFolderInfo = tFileInfo

End Function

